<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: class/proceso.php
// Tipo: definicion de clase
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: gestiona los procesos
//---------------------------------------------------------------------------------------------------
class proceso 
{
   //Propiedades de la clase
   var $id_proceso;
   var $datos = array();
   var $database; //objeto de conexion a la base de datos
   var $error; //propiedad de uso interno para almacenar los errores
   
   // Metodos de la clase
   function proceso($database) 
   {
      $this->database = $database;
   }

      
   // Obtiene los datos de la proceso 
   function obtener_datos($id_proceso) 
   {
	  $consulta = "SELECT *, p.nombre as nombre, u.nombre as nombre_propietario, 
		   u.apellidos as apellidos_propietario 
		   FROM proceso p INNER JOIN usuario u ON p.id_propietario = u.id_usuario
		   WHERE id_proceso=$id_proceso";

      $this->database->ejecutar_consulta($consulta);
      if ($this->database->filas_implicadas > 0) 
      {
		  $this->database->obtener_fila();
		  $this->datos = $this->database->fila;
          return $this->datos;
      }
      else 
      {
		  $this->error = "No existe ning&uacute;n proceso con el identificador $id_proceso.";
	      return FALSE;
	  }
   }
   
	function crear ($codigo, $nombre, $id_propietario, $id_entidad) 
	{
		//Primero compruebo que no exista otra proceso con el mismo nombre en la base de datos
		$consulta = "SELECT * FROM proceso WHERE codigo = '" . $codigo  . "'";
		$this->database->ejecutar_consulta($consulta);
		if ($this->database->filas_implicadas == 0) 
		{
			//Si la consulta no devuelve ninguna fila el codigo no existe en la base de datos 
			//y podemos grabar la nueva proceso
			$consulta = "INSERT INTO proceso (codigo,nombre,id_propietario,id_entidad) 
				VALUES ('$codigo','$nombre','$id_propietario','$id_entidad')";
			if ($this->database->ejecutar_consulta($consulta))
			{	
				$id_proceso = $this->database->obtener_ultima_id();
				$datos = $this->obtener_datos($id_proceso); 
				return $datos;
			}
			else 
			{
				$this->error = "No se ha podido grabar el proceso en la base de datos";
				return false;
			}
		}
		else 
		{
			//Si la consulta devuelve alguna fila el codigo ya existe y no grabamos
			$this->error = "El c&oacute;digo del proceso '" . $codigo  . "' ya existe en el sistema";
			return false;
		}
    }	   
   
	function modificar($id_proceso, $codigo, $nombre, $id_propietario)
	{ 
		$consulta = "UPDATE proceso SET nombre='$nombre', codigo='$codigo', 
			id_propietario=$id_propietario  WHERE id_proceso = $id_proceso";
		
		if ($this->database->ejecutar_consulta($consulta))
		{
			return true;
		}
		else
		{
			$this->error = "No se han podido actualizar los datos del proceso $id_proceso";
			return false;
		}
	}
} 
