<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (https://forja.rediris.es/projects/icasus/)
// Archivo: proceso_crear.php
// Tipo: controlador
// Desarrolladores: Juanan Ruiz (juanan@us.es), Jesús Martín (jjmc@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: Creación de nuevos procesos
//---------------------------------------------------------------------------------------------------

global $smarty;
global $basedatos;
global $plantilla;

$id_entidad = sanitize($_REQUEST['id_entidad'],16);
$entidad = new entidad($basedatos);
$datos_entidad = $entidad->obtener_datos($id_entidad);
$smarty->assign('_nombre_pagina',$entidad->datos['nombre']);

// Si vienen todos los datos necesarios del formulario grabamos
if (isset($_POST['nombre']) && isset($_POST['codigo']) && isset($_POST['id_propietario']))
{
	$nombre = sanitize($_POST['nombre'],2);
	$codigo = sanitize($_POST['codigo'],2);
	$id_propietario = sanitize($_POST['id_propietario'],16);
	$proceso = new proceso($basedatos);
	if ($proceso->crear($codigo,$nombre,$id_propietario,$id_entidad))
	{
		$smarty->assign('entidad' , $entidad->obtener_datos($id_entidad));
		$smarty->assign('usuarios' , $entidad->listar_usuarios($id_entidad));
		$smarty->assign('procesos' , $entidad->listar_procesos($id_entidad));
		$smarty->assign('aviso' , 'El proceso se ha creado correctamente');
		$plantilla = "entidad_datos.tpl";
	}
	else
	{
		$smarty->assign('error', $proceso->error); 
		$smarty->assign('_nombre_pagina','Error');
		$plantilla = 'error.tpl';
	}
}
// Si no vienen datos mostramos el formulario
else
{
	$smarty->assign('entidad', $datos_entidad);
	$smarty->assign('usuarios', $entidad->listar_usuarios($id_entidad));
	$plantilla = "proceso_crear.tpl";
}
?>
