<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (https://forja.rediris.es/projects/icasus/)
// Archivo: proceso_editar.php
// Tipo: controlador
// Desarrolladores: Juanan Ruiz (juanan@us.es), Jesús Martín (jjmc@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: Modifica procesos existentes
//---------------------------------------------------------------------------------------------------

global $smarty;
global $basedatos;
global $plantilla;

// Para empezar a hablar necesitamos el id del proceso
if (isset($_REQUEST['id_proceso']))
{
	$id_proceso = sanitize($_REQUEST['id_proceso'],16);
	$id_entidad = sanitize($_REQUEST['id_entidad'],16);
	$entidad = new entidad($basedatos);
	$datos_entidad = $entidad->obtener_datos($id_entidad);
	$smarty->assign('_nombre_pagina',$entidad->datos['nombre']);

	// Si vienen todos los datos necesarios del formulario grabamos
	if (isset($_POST['nombre']) && isset($_POST['codigo']))
	{
		$nombre = sanitize($_POST['nombre'],2);
		$codigo = sanitize($_POST['codigo'],2);
		$id_propietario = isset($_POST['id_propietario'])?sanitize($_POST['id_propietario'],16):null;
		$proceso = new proceso($basedatos);
		if ($proceso->modificar($id_proceso, $codigo, $nombre, $id_propietario))
		{
			$smarty->assign('entidad' , $entidad->obtener_datos($id_entidad));
			$smarty->assign('usuarios' , $entidad->listar_usuarios($id_entidad));
			$smarty->assign('procesos' , $entidad->listar_procesos($id_entidad));
			$smarty->assign('aviso' , 'El proceso se ha modificado correctamente');
			$plantilla = "entidad_datos.tpl";
		}
		else
		{
			$smarty->assign('error', $proceso->error); 
			$smarty->assign('_nombre_pagina','Error');
			$plantilla = 'error.tpl';
		}
	}
	// Si no vienen datos mostramos el formulario
	else
	{
		$proceso = new proceso($basedatos);
		$smarty->assign('proceso', $proceso->obtener_datos($id_proceso));
		$smarty->assign('entidad', $datos_entidad);
		$smarty->assign('usuarios', $entidad->listar_usuarios($id_entidad));
		$plantilla = "proceso_editar.tpl";
	}
}
else
{
	$error = 'Faltan parametros para editar un proceso';
	$smarty->assign('error', $error);
	$smarty->assign('_nombre_pagina' , 'Error'); 
	$plantilla = 'error.tpl';
}
?>
