<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: valor_crear.php
// Desarrolladores: Juanan Ruiz (juanan@us.es), Jesús Martín (jjmc@us.es) 
//---------------------------------------------------------------------------------------------------
// Descripcion: Añadir un nuevo valor o medición a un indicador
//---------------------------------------------------------------------------------------------------
require_once('function/sanitize.php');
global $smarty;
global $basedatos;
global $plantilla;
$smarty->assign('_javascript' , array('valor_validar'));

if (isset($_REQUEST['id_indicador']) && isset($_REQUEST['id_entidad']) )
{
	$id_entidad = sanitize($_REQUEST['id_entidad'],16);
	$id_indicador = sanitize($_REQUEST['id_indicador'],16);
	$entidad = new entidad($basedatos);
	$smarty->assign('entidad' , $entidad->obtener_datos($id_entidad));
	$indicador = new indicador($basedatos);
	$smarty->assign('indicador', $indicador->obtener_datos($id_indicador));
	$smarty->assign('_nombre_pagina' , $indicador->datos['entidad']); 
	$plantilla = 'indicador_datos.tpl';
	// Comprueba si vienen los datos necesarios para grabar un nuevo valor
	if (isset($_POST['dato_valor']) && isset($_POST['periodo']))
	{
		$dato_valor = sanitize($_POST['dato_valor'],2);
		$periodo = sanitize($_POST['periodo'],2);
		$month = sanitize($_POST['Date_Month'],2);
		$day = sanitize($_POST['Date_Day'],2);
		$year = sanitize($_POST['Date_Year'],2);
		$fecha_recogida = mktime(0, 0, 0, $month, $day, $year);
		$valor = new valor($basedatos);
		if ($valor->crear($id_indicador, $operario->id_usuario, $dato_valor, $periodo, $fecha_recogida)) 
		{
			$smarty->assign('aviso' , 'El nuevo valor se ha grabado correctamente.');
			$smarty->assign('valores' , $indicador->listar_valores($id_indicador));
		}
		else
		{
			$smarty->assign('error', $valor->error); 
		}
	}
	// Si no vienen datos suficientes mostramos el formulario en blanco o con los datos enviados
	else
	{
		$smarty->assign('valor' , $_POST);
		$smarty->assign('_nombre_pagina', $indicador->datos['entidad']);
		$plantilla = 'valor_crear.tpl';
	}
}
else // falta id_indicador o id_entidad
{
	$smarty->assign('error', 'Faltan parámetros para realizar esta acción.'); 
	$smarty->assign('_nombre_pagina','Error');
	$plantilla = 'error.tpl';
}
?>
