<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: formulario_valor.php
// Desarrolladores: Juanan Ruiz (juanan@us.es), Jesús Martín (jjmc@us.es) 
//---------------------------------------------------------------------------------------------------
// Descripcion: Editar valores de un indicador
//---------------------------------------------------------------------------------------------------
require_once('function/sanitize.php');
global $smarty;
global $basedatos;
global $plantilla;

$smarty->assign('_javascript' , array('valor_validar','ordenatabla'));

if (isset($_REQUEST['id_indicador']) && isset($_REQUEST['id_entidad']) && isset($_REQUEST['id_valor']))
{
	$id_entidad = sanitize($_REQUEST['id_entidad'],16);
	$id_indicador = sanitize($_REQUEST['id_indicador'],16);
	$id_valor = sanitize($_REQUEST['id_valor'],16);
	$entidad = new entidad($basedatos);
	$valor = new valor($basedatos);
	$indicador = new indicador($basedatos);
	$smarty->assign('entidad' , $entidad->obtener_datos($id_entidad));
	$smarty->assign('indicador' , $indicador->obtener_datos($id_indicador));
	$smarty->assign('valores' , $indicador->listar_valores($id_indicador));
	$smarty->assign('_nombre_pagina' , $indicador->datos['entidad']); 
	$plantilla = 'indicador_datos.tpl';
	// Comprobamos si vienen los datos necesarios para editar el valor
	if (isset($_POST['dato_valor']) && isset($_POST['periodo']))
	{
		$dato_valor = sanitize($_POST['dato_valor'],2);
		$periodo = sanitize($_POST['periodo'],2);
		$month = sanitize($_POST['Date_Month'],2);
		$day = sanitize($_POST['Date_Day'],2);
		$year = sanitize($_POST['Date_Year'],2);
		$fecha_recogida = mktime(0, 0, 0, $month, $day, $year);

		if ($valor->modificar($id_valor, $operario->id_usuario, $dato_valor, $periodo, $fecha_recogida)) 
		{
			$smarty->assign('aviso' , 'Los cambios se han grabado correctamente.');
			$smarty->assign('valores' , $indicador->listar_valores($id_indicador));
		}
		else
		{
			$smarty->assign('error', $valor->error); 
		}
	}
	// Si no vienen datos suficientes mostramos el formulario en blanco o con los datos enviados
	else
	{
		$smarty->assign('valor' , $valor->obtener_datos($id_valor));
		$plantilla = 'valor_editar.tpl';
	}
}
else // falta id_indicador o id_entidad
{
	$smarty->assign('error', 'Faltan parámetros para realizar esta acción.'); 
	$smarty->assign('_nombre_pagina','Error');
	$plantilla = 'error.tpl';
}
?>
